require 'rails/generators/resource_helpers'

module Mizugumo
  class JsAssetsGenerator < Rails::Generators::NamedBase
    include ::Rails::Generators::ResourceHelpers
  
    self.namespace("rails:mizugumo:js_assets")

    def write_javascript 
      return unless Mizugumo::RAILS_31
      create_file(File.join('app/assets/javascripts', "#{plural_table_name}.js")) do <<-EOJS
Ninja.orders(function(Ninja){        
  Ninja.behavior({
    // Generated by the mizugumo scaffold
    // AJAX behavior for edit, new, and delete actions; applies to both forms and links
    '.new_#{singular_table_name}': Ninja.submitsAsAjax,
    '.edit_#{singular_table_name}': Ninja.submitsAsAjax,
    '.delete_#{singular_table_name}': Ninja.submitsAsAjax
  });
});
EOJS
      end
    end     
  end
end

